// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	consolev1 "github.com/openshift/api/console/v1"
	versioned "github.com/openshift/client-go/console/clientset/versioned"
	internalinterfaces "github.com/openshift/client-go/console/informers/externalversions/internalinterfaces"
	v1 "github.com/openshift/client-go/console/listers/console/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// ConsoleLinkInformer provides access to a shared informer and lister for
// ConsoleLinks.
type ConsoleLinkInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.ConsoleLinkLister
}

type consoleLinkInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewConsoleLinkInformer constructs a new informer for ConsoleLink type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewConsoleLinkInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredConsoleLinkInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredConsoleLinkInformer constructs a new informer for ConsoleLink type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredConsoleLinkInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ConsoleV1().ConsoleLinks().List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ConsoleV1().ConsoleLinks().Watch(context.TODO(), options)
			},
		},
		&consolev1.ConsoleLink{},
		resyncPeriod,
		indexers,
	)
}

func (f *consoleLinkInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredConsoleLinkInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *consoleLinkInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&consolev1.ConsoleLink{}, f.defaultInformer)
}

func (f *consoleLinkInformer) Lister() v1.ConsoleLinkLister {
	return v1.NewConsoleLinkLister(f.Informer().GetIndexer())
}
